package com.sun.grizzly.grizzlet;

import com.sun.grizzly.container.GrizzletRequest;
import com.sun.grizzly.container.GrizzletResponse;
import java.io.IOException;


/**
 * Simple Flickr Magnet Demo.
 *
 * @author Jeanfrancois Arcand
 * @author Greg Murray
 */
public class JMakiGrizzlet implements Grizzlet {

    /**
     * Simple counter
     */
    private int counter;

    public void onRequest(AsyncConnection ac) throws IOException {
        GrizzletRequest req = ac.getRequest();
        GrizzletResponse res = ac.getResponse();

        String[] actionValues = req.getParameterValues("action");
        if (actionValues != null && actionValues[0] != null) {
            String action = req.getParameterValues("action")[0];
            if ("post".equals(action)) {
                String message = req.getParameterValues("message")[0];
                String callback = req.getParameterValues("callback")[0];
                if (callback == null) {
                    callback = "alert";
                }

                // Notify other registered CometHandler.
                ac.push("<script id='comet_" + counter++ + "'>" + "window.parent." 
                        + callback + "(" + message + ");</script>");
                res.write("ok");
                res.flush();
                return;
            } else if ("start".equals(action)) {
                res.setContentType("text/html");
                String callback = req.getParameterValues("callback")[0];
                if (callback == null) {
                    callback = "alert";
                }

                String message = "{ message : 'Welcome'}";
                res.write("<script id='comet_" + counter++ + "'>" + "window.parent."
                        + callback + "(" + message + ");</script>");
                res.write("<html><head><title>jMaki Grizzly Comet Words Sample</title></head><body bgcolor=\"#FFFFFF\">");
                res.flush();

                if (ac.isGet()) {
                    ac.suspend();
                }
                return;
            }
        }
    }

    public void onPush(AsyncConnection ac) throws IOException {
        GrizzletRequest req = ac.getRequest();
        GrizzletResponse res = ac.getResponse();

        if (ac.isResuming()) {
            res.write("jMaki Grizzly Comet Words Sample closed<br/>");
            res.write("</body></html>");
            res.flush();
            res.finish();
        } else if (ac.hasPushEvent()) {
            res.write(ac.getPushEvent().toString());
            res.flush();
        }
    }

}